package net.flashii.mcexts;

import org.bukkit.event.player.PlayerListener;
import org.bukkit.event.player.PlayerLoginEvent;
import org.bukkit.event.player.PlayerLoginEvent.Result;

public class JoinListener extends PlayerListener {
    @Override
    public void onPlayerLogin(PlayerLoginEvent ev) {
        if(ev.getResult() != Result.ALLOWED)
            return;

        String authText = null;

        try {
            RPCPayload payload = RPC.postAuth(ev.getPlayer().getDisplayName(), ev.getKickMessage());

            if(!payload.is("auth:ok")) {
                if(payload.is("error")) {
                    authText = payload.getAttrStr(payload.hasAttr("text") ? "text" : "code");
                } else if(payload.is("auth:authorise")) {
                    String userName = payload.getAttrStr("user_name");
                    String url = payload.getAttrStr("url");

                    if(userName.length() > 20)
                        userName = userName.substring(0, 20);

                    authText = "Welcome back, " + userName + "! Go to " + url + " to verify yourself.";
                } else if(payload.is("auth:link")) {
                    String code = payload.getAttrStr("code");
                    String url = payload.getAttrStr("url");

                    authText = "Visit " + url + " to connect your Flashii ID. Link code: " + code;
                } else {
                    authText = "Flashii server returned unknown response, yell at flashwave about this.";
                }
            }
        } catch(Exception ex) {
            authText = "There was a serious problem during authentication, yell at flashwave about this.";
            ex.printStackTrace();
        }

        if(authText == null)
            ev.allow();
        else
            ev.disallow(Result.KICK_OTHER, authText);
    }
}
