package net.flashii.mcexts.mixin;

import net.flashii.mcexts.URLs;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfoReturnable;

@Mixin(targets = "com.mojang.authlib.Environment$1")
public abstract class EnvironmentMixin {
    @Inject(method = "getSessionHost()Ljava/lang/String;", at = @At("HEAD"), cancellable = true, remap = false)
    private void getSessionHost(CallbackInfoReturnable<String> cir) {
        cir.setReturnValue(URLs.getSessionHost());
        cir.cancel();
    }
}
