package net.flashii.mcexts.mixin;

import com.mojang.authlib.yggdrasil.TextureUrlChecker;
import net.flashii.mcexts.URLs;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfoReturnable;

@Mixin(TextureUrlChecker.class)
public abstract class TextureUrlCheckerMixin {
    @Inject(method = "isAllowedTextureDomain(Ljava/lang/String;)Z", at = @At("HEAD"), cancellable = true, remap = false)
    private static void isAllowedTextureDomain(String url, CallbackInfoReturnable<Boolean> cir) {
        if(url == null || url.startsWith(URLs.getTexturesHostPrefix())) {
            cir.setReturnValue(true);
            cir.cancel();
        }
    }
}
