package net.flashii.mcexts;

import java.util.HashMap;
import java.util.Iterator;
import org.json.simple.JSONArray;
import org.json.simple.JSONObject;
import org.json.simple.parser.ParseException;
import org.json.simple.parser.JSONParser;

public class RPCPayloadParser {
    private final JSONParser parser = new JSONParser();

    public RPCPayload parse(String body)
        throws ParseException {
        JSONObject root = (JSONObject)parser.parse(body);
        String name = (String)root.get("name");
        HashMap<String, Object> attrs = new HashMap<>();

        @SuppressWarnings("unchecked")
        Iterator<JSONObject> attrsIterator = ((JSONArray)root.get("attrs")).iterator();
        while(attrsIterator.hasNext()) {
            JSONObject attrInfo = attrsIterator.next();
            attrs.put(
                (String)attrInfo.get("name"),
                attrInfo.get("value")
            );
        }

        return new RPCPayload(name, attrs);
    }
}
