package net.flashii.mcexts;

import java.nio.charset.StandardCharsets;
import java.security.GeneralSecurityException;
import javax.crypto.Mac;
import javax.crypto.spec.SecretKeySpec;

public class HMAC {
    public static final String SHA256 = "HmacSHA256";

    public static byte[] calculate(String method, String secret, String data)
        throws GeneralSecurityException {
        return calculate(method, secret.getBytes(StandardCharsets.UTF_8), data.getBytes(StandardCharsets.UTF_8));
    }

    public static byte[] calculate(String method, byte[] secret, String data)
        throws GeneralSecurityException {
        return calculate(method, secret, data.getBytes(StandardCharsets.UTF_8));
    }

    public static byte[] calculate(String method, String secret, byte[] data)
        throws GeneralSecurityException {
        return calculate(method, secret.getBytes(StandardCharsets.UTF_8), data);
    }

    public static byte[] calculate(String method, byte[] secret, byte[] data)
        throws GeneralSecurityException {
        Mac hmac = Mac.getInstance(method);
        hmac.init(new SecretKeySpec(secret, method));
        return hmac.doFinal(data);
    }
}
